﻿using System.Collections.Specialized;
using System.Windows;
using System.Windows.Controls;

using Prism.Regions;

namespace TestProject
{
    /// <summary>
    /// 스택 패널 영역 어댑터
    /// </summary>
    public class StackPanelRegionAdapter : RegionAdapterBase<StackPanel>
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - StackPanelRegionAdapter(regionBehaviorFactory)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="regionBehaviorFactory">영역 BEHAVIOR 팩토리 인터페이스</param>
        public StackPanelRegionAdapter(IRegionBehaviorFactory regionBehaviorFactory) : base(regionBehaviorFactory)
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 채택하기 - Adapt(region, regionTarget)

        /// <summary>
        /// 채택하기
        /// </summary>
        /// <param name="region">영역</param>
        /// <param name="regionTarget">영역 타겟</param>
        protected override void Adapt(IRegion region, StackPanel regionTarget)
        {
            region.Views.CollectionChanged += (s, e) =>
            {
                if(e.Action == NotifyCollectionChangedAction.Add)
                {
                    foreach(FrameworkElement element in e.NewItems)
                    {
                        regionTarget.Children.Add(element);
                    }
                }
            };
        }

        #endregion
        #region 영역 생성하기 - CreateRegion()

        /// <summary>
        /// 영역 생성하기
        /// </summary>
        /// <returns>영역 인터페이스</returns>
        protected override IRegion CreateRegion()
        {
            return new AllActiveRegion();
        }

        #endregion
    }
}